# -*- coding: utf-8 -*-
"""
Created on Thu Apr 23 12:56:22 2020

@author: estefania.heredia
"""

import pandas as pd
import numpy as np
from settings import FEATURES_DICT, TXT_SEMESTRES_DICT

#cuando p2 sea igual a 0.
#muy alta	(p8 , 1 ]
#alta	(p6 , p8 ]
#medio	(p4 , p6 ]
#bajo	(p2 , p4 ]
#muy bajo	[ 0 , p2 ]

#cuando p8 será igual a 1.
#muy alta	(p8 , 1 ]
#alta	(p6 , p8 )
#medio	(p4 , p6 ]
#bajo	(p2 , p4 ]
#muy bajo	[ 0 , p2 ]
def analizeDataPredicted(datosBD, weightsBD, infoDegree, metricas):
    """
    Created on Thu Sep 12 15:21:41 2019

    @author: estefania.heredia
    """
    dataV = datosBD.copy()
    dataV['tipoRetencion'] = ''
    dataV['frase'] = ''

    percentilesDB = pd.DataFrame()

    txt_start = "{'variables':["
    txt_star_2 = "{'variable':["
    txt_end = "]}]}"

    #carrera = "LI002"

    df_c2 = pd.DataFrame(columns=dataV.columns)
    df_w2 = pd.DataFrame(columns=weightsBD.columns)

    dataFinalDB = pd.DataFrame(columns=dataV.columns)

    carrerasP = pd.DataFrame(datosBD.degree.unique(), columns=['degree'])

    for carrera in carrerasP['degree']:
        df_c = datosBD[(datosBD['degree'] == carrera)]
        df_c = df_c.sort_values(by=['Semestres', 'id'], ascending=True)

        w_c = weightsBD[(weightsBD['degree'] == carrera)]
        w_c = w_c.sort_values(by=['Semestres', 'id'], ascending=True)
        df_w2 = df_w2.append(w_c)
        #i = 1
        for semestre in range(6):
            if (semestre+1) > 5:
                df_est_semestre = df_c[(df_c['Semestres'] >= (semestre+1))]
                df_est_sem_per_sin0 = df_c[df_c['dropout']>0]
                df_est_sem_per_sin0_sin1 = df_est_sem_per_sin0[df_est_sem_per_sin0['dropout']<1]
                percentiles = round(df_est_sem_per_sin0_sin1.dropout.quantile([0.2, 0.4, 0.6, 0.8]), 2)
            else:
                df_est_semestre = df_c[(df_c['Semestres'] == (semestre+1))]
                df_est_sem_per = df_c[(df_c['Semestres'] <= (semestre+1))]
                df_est_sem_per_sin0 = df_c[df_c['dropout']>0]
                df_est_sem_per_sin0_sin1 = df_est_sem_per_sin0[df_est_sem_per_sin0['dropout']<1]
                percentiles = round(df_est_sem_per_sin0_sin1.dropout.quantile([0.2, 0.4, 0.6, 0.8]), 2)

            if df_est_semestre.shape[0] > 0: #si hay studs en ese semestre
                sem_str = carrera + "Sem" +str(semestre+1)
                index_ = ['per2', 'per4', 'per6', 'per8']
                percentiles.index = index_
                percentiles_df = pd.DataFrame(percentiles)
                percentiles_df.columns = [sem_str]
                percentilesDB = pd.concat([percentilesDB, percentiles_df.T])

                if percentiles.loc['per2'] == 0:
                    conditions = [(df_est_semestre['dropout'] <= percentiles.loc['per2']),
                                  ((df_est_semestre['dropout'] > percentiles.loc['per2']) & (df_est_semestre['dropout'] <= percentiles.loc['per4'])),
                                  ((df_est_semestre['dropout'] > percentiles.loc['per4']) & (df_est_semestre['dropout'] <= percentiles.loc['per6'])),
                                  ((df_est_semestre['dropout'] > percentiles.loc['per6']) & (df_est_semestre['dropout'] <= percentiles.loc['per8'])),
                                  (df_est_semestre['dropout'] > percentiles.loc['per8'])
                                  ]
                elif percentiles.loc['per8'] == 1:
                    conditions = [(df_est_semestre['dropout'] <= percentiles.loc['per2']),
                                  ((df_est_semestre['dropout'] > percentiles.loc['per2']) & (df_est_semestre['dropout'] <= percentiles.loc['per4'])),
                                  ((df_est_semestre['dropout'] > percentiles.loc['per4']) & (df_est_semestre['dropout'] <= percentiles.loc['per6'])),
                                  ((df_est_semestre['dropout'] > percentiles.loc['per6']) & (df_est_semestre['dropout'] < percentiles.loc['per8'])),
                                  (df_est_semestre['dropout'] > percentiles.loc['per8'])
                                  ]
                else:
                    conditions = [(df_est_semestre['dropout'] < percentiles.loc['per2']),
                                  ((df_est_semestre['dropout'] >= percentiles.loc['per2']) & (df_est_semestre['dropout'] < percentiles.loc['per4'])),
                                  ((df_est_semestre['dropout'] >= percentiles.loc['per4']) & (df_est_semestre['dropout'] < percentiles.loc['per6'])),
                                  ((df_est_semestre['dropout'] >= percentiles.loc['per6']) & (df_est_semestre['dropout'] < percentiles.loc['per8'])),
                                  (df_est_semestre['dropout'] >= percentiles.loc['per8'])
                                  ]

                choices = ['Muy bajo', 'Bajo', 'Medio', 'Alto', 'Muy alto']
                df_est_semestre['tipoRetencion'] = np.select(conditions, choices, default='Muy bajo')

                df_c2 = df_c2.append(df_est_semestre)


    df_c2 = df_c2.reset_index(drop=True)
    df_w2 = df_w2.reset_index(drop=True)

    for pos in range(len(df_c2)):
        frase = ""
        data_est = df_c2[(df_c2.index == pos)]
        weigth_est = df_w2[(df_w2.index == pos)]

        carrera = data_est['degree'].values[0]
        id_est = data_est['id'].values[0]

        sem_int = data_est['Semestres'].values[0]
        sem_str = sem_str2 = ""


        if sem_int <= 5:
            sem_str = carrera + "Sem" +str(sem_int)
            sem_str2 = "Sem" +str(sem_int)
        else:
            sem_str = carrera + "Sem6"
            sem_str2 = "Sem6"

        acc = round(metricas[sem_str]['accuracy'][0], 2) *100

        weigth_est = weigth_est.drop('id', 1).drop('Semestres', 1).drop('degree', 1)
        weigth_est_abs = weigth_est.abs()
        weigth_est_abs = weigth_est_abs.sort_values(weigth_est_abs.last_valid_index(), axis=1, ascending=False)
        weigth_est_norm = round((weigth_est_abs.div(weigth_est_abs.sum(axis=1), axis=0) * 100), 2)
        weigth_est_norm2 = weigth_est_norm.loc[:, (weigth_est_norm != 0).any(axis=0)]


        txt_retencion = "{'variable':'"+str(round((data_est['dropout'].values[0]*100), 2))+"', 'nivel_confianza':'"+str(acc)+"%', 'tipo_riesgo':'"+ data_est['tipoRetencion'].values[0]+"'},"

        txt_variables = ""
        for j in range(len(weigth_est_norm2.columns)):
            name_col_long = weigth_est_norm2.columns[j]
            val = data_est[name_col_long].values[0]

            if name_col_long in "gapAnios":
                val = val * 2
                val = val.astype(int)
            if name_col_long in ("segMat", "terMat"):
                val = val.astype(int)

            txt_subvariable = "{'subvariable':'"+FEATURES_DICT[name_col_long].short_name+"',"
            txt_subvariable = txt_subvariable + "'valor':'"+str(weigth_est_norm2[name_col_long].values[0])+"',"
            txt_subvariable = txt_subvariable + "'descripcion':["

            txt_subvariable = txt_subvariable + "'"+FEATURES_DICT[name_col_long].descrip_calc+"',"
            txt_subvariable = txt_subvariable + "'"+FEATURES_DICT[name_col_long].val_txt+str(val)+"'"

            if FEATURES_DICT[name_col_long].descrip_adic == 1:
                if name_col_long == "mediaAPRPTotal":
                    val_ap = round(infoDegree[sem_str].mediaCarreraGraduadosAPRPTotal, 2)
                    val_rp = round(infoDegree[sem_str].mediaCarreraAbandonadosAPRPTotal, 2)

                if sem_str2 == "Sem1":
                    txt_ext = ",'Los estudiantes que se graduaron en la carrera, durante su"+TXT_SEMESTRES_DICT[sem_str2].txt+"semestre cursado, tienen una media de: "+ str(val_ap) +"'"
                    txt_ext = txt_ext + ",'Los estudiantes que no continuaron en la carrera, durante su"+TXT_SEMESTRES_DICT[sem_str2].txt+"semestre cursado, tienen una media de: "+ str(val_rp) +"'"
                elif sem_str2 not in ("Sem1", "Sem6"):
                    txt_ext = ",'Los estudiantes que se graduaron en la carrera, durante sus"+TXT_SEMESTRES_DICT[sem_str2].txt+"primeros semestres cursados, tienen una media de: "+ str(val_ap) +"'"
                    txt_ext = txt_ext + ",'Los estudiantes que no continuaron en la carrera, durante sus"+TXT_SEMESTRES_DICT[sem_str2].txt+"primeros semestres cursados, tienen una media de: "+ str(val_rp) +"'"
                else:
                    txt_ext = ",'Los estudiantes que se graduaron en la carrera, durante sus semestres cursados, tienen una media de: "+ str(val_ap) +"'"
                    txt_ext = txt_ext + ",'Los estudiantes que no continuaron en la carrera, durante sus semestres cursados, tienen una media de: "+ str(val_rp) +"'"


                txt_subvariable = txt_subvariable + txt_ext +"]}"
            else:
                txt_subvariable = txt_subvariable + "]}"

            if j != (len(weigth_est_norm2.columns)-1):
                txt_subvariable = txt_subvariable + ","

            txt_variables = txt_variables + txt_subvariable


        frase = txt_start + txt_retencion + txt_star_2 + txt_variables  + txt_end
        df_c2.loc[df_c2['id'] == id_est, 'frase'] = frase


    dataFinalDB = dataFinalDB.append(df_c2)

    return dataFinalDB, percentilesDB
