# -*- coding: utf-8 -*-
"""
Created on Sun Apr  5 18:32:09 2020

@author: estefania.heredia
"""
import pandas as pd

from settings import DROPOUT_VAL, RETENTION_VAL
   
def getInfoDegree(dataCarrera):
    
    data = dataCarrera.copy()
    
    aprobados = data[data['dropout'] == RETENTION_VAL]
    abandonados = data[data['dropout'] == DROPOUT_VAL]
    #abandonados = abandonados[abandonados['mediaAP'] != 0]
    #mediaCarreraAP = aprobados.groupby(['degree']).mediaAP.sum().to_frame()/aprobados.groupby(['degree']).mediaAP.count().to_frame()
    #mediaCarreraRP = abandonados.groupby(['degree']).mediaAP.sum().to_frame()/abandonados.groupby(['degree']).mediaAP.count().to_frame()
    mediaCarreraAPRPGradTomadas = aprobados.groupby(['degree']).mediaAPRPTomadas.sum().to_frame()/aprobados.groupby(['degree']).mediaAPRPTomadas.count().to_frame()
    mediaCarreraAPRPAbandonTomadas = abandonados.groupby(['degree']).mediaAPRPTomadas.sum().to_frame()/abandonados.groupby(['degree']).mediaAPRPTomadas.count().to_frame()
    mediaCarreraAPRPGradTotal = aprobados.groupby(['degree']).mediaAPRPTotal.sum().to_frame()/aprobados.groupby(['degree']).mediaAPRPTotal.count().to_frame()
    mediaCarreraAPRPAbandonTotal = abandonados.groupby(['degree']).mediaAPRPTotal.sum().to_frame()/abandonados.groupby(['degree']).mediaAPRPTotal.count().to_frame()

    infoGeneralCarrera = pd.Series() 
    

    #infoGeneralCarrera['mediaCarreraGraduadosAP'] = mediaCarreraAP['mediaAP'].values[0]
    #infoGeneralCarrera['mediaCarreraAbandonadosAP'] = mediaCarreraRP['mediaAP'].values[0]
    infoGeneralCarrera['mediaCarreraGraduadosAPRPTomadas'] = mediaCarreraAPRPGradTomadas['mediaAPRPTomadas'].values[0]
    infoGeneralCarrera['mediaCarreraAbandonadosAPRPTomadas'] = mediaCarreraAPRPAbandonTomadas['mediaAPRPTomadas'].values[0]
    infoGeneralCarrera['mediaCarreraGraduadosAPRPTotal'] = mediaCarreraAPRPGradTotal['mediaAPRPTotal'].values[0]
    infoGeneralCarrera['mediaCarreraAbandonadosAPRPTotal'] = mediaCarreraAPRPAbandonTotal['mediaAPRPTotal'].values[0]

    return infoGeneralCarrera