# -*- coding: utf-8 -*-
"""
Created on Thu Apr  9 10:32:53 2020

@author: estefania.heredia
"""
import pandas as pd
import functionsVar
import get_estudiante
import get_historialEstudiante2

def preprocessingDataAcademica(estudiantes, historial):
    """This module preprocess the student data from DB, normalizes and selects the columns to use

    Parameters:
    estudiantes (dataframe): Description of arg1

    Returns:
    df (dataframe): Returning value

    """
    print("Comenzo el preprocesamiento de la data estudiante e historial")
    
    #print("Calcularo el factor economico")
    #factor_excel, factor_no_inserted, estudiantes = functionsVar.calcularFactorEcnonomico(estudiantes)
    
    print("Preprocesando data estudiantes")
    data_estudiantes = get_estudiante.cambEstudiante(estudiantes)
    
    print("Preprocesando data historial")
    data_estudiantes, data_historial = get_historialEstudiante2.historialEstudiante(
        data_estudiantes, historial)

    carreras = pd.DataFrame(data_historial.codDegree.unique(), columns=['degree'])

    return data_estudiantes, data_historial, carreras
