# -*- coding: utf-8 -*-
"""
Created on Mon Sep 23 17:01:05 2019

@author: estefania.heredia
"""

import time 
import pandas as pd 

#col_name final dspues d get_estudiante
#names = ["civil","work","schType","city","sex","codDegree","totCredits","stateStudent","id"]
HOST='200.10.150.52'

DATABASE='lala_uc3m'

USER='lala_usr'

PASSWORD='0t3H@hG&'

ANIO_ACTUAL = int(time.strftime("%Y"))

SEMESTRE_ACTUAL = 1

ANIO_LIMIT_MATRICULA = 5

DROPOUT_VAL = 0

RETENTION_VAL = 1

COL_NAMES_HISTORIAL_DF = ["codSubject", "subState", "call", "year", "semester", 
                          "notaFinal", "credMateria", "tipoCredito", "idTb", 
                          "codDegree", "tomada", "id", "semesterNum", "numTermino"]

COL_NAMES_ESTUDIANTES_DF = ["civil", "work", "schType", "city", "economicFactor", "sex", "codDegree",
                            "totCredits", "stateStudent", "matricula", "id", "ultMat", "aniosEst",
                            "dropout"]    

FEATURES_DICT = pd.DataFrame({
        "segMat": {"short_name": "2da matrícula", 
                   "descrip_calc": "Número de veces que el estudiante ha llegado a 2da matricula", 
                   "val_txt": "Veces: ",
                   "descrip_adic":0},
        "terMat": {"short_name": "3era matrícula", 
                   "descrip_calc": "Número de veces que el estudiante ha llegado a 3era matrícula", 
                   "val_txt": "Veces: ",
                   "descrip_adic":0},
        "gapAnios": {"short_name": "Semestres no tomados", 
                   "descrip_calc": "Número de semestres que el estudiante lleva sin estudiar entre semestres", 
                   "val_txt": "Semestres sin estudiar: ",
                   "descrip_adic":0},
        "ratePassFinal": {"short_name": "Tasa de aprobación", 
                   "descrip_calc": "Tasa de materias aprobadas por el estudiante", 
                   "val_txt": "% de aprobación: ",
                   "descrip_adic":0},
        "rateFailFinal": {"short_name": "Tasa de reprobación", 
                   "descrip_calc": "Tasa de materias reprobadas por el estudiante", 
                   "val_txt": "% de reprobación: ",
                   "descrip_adic":0},
        "rateCancelFinal": {"short_name": "Tasa de anulación", 
                   "descrip_calc": "Tasa de materias anuladas por el estudiante", 
                   "val_txt": "% de anulación: ",
                   "descrip_adic":0},
        "economicFactor": {"short_name": "Factor socioeconómico", 
                   "descrip_calc": "Factor socioeconómico es una unificación de factor P, GMS, ISE, obtenido a una sola escala de 0 a 1", 
                   "val_txt": "Factor socioeconoómico: ",
                   "descrip_adic":0},
        "mediaAPRPTotal": {"short_name": "Promedio de todas las materias", 
                   "descrip_calc": "Promedio de todas las materias (aprobadas, reprobadas, convalidadas y acreditadas) que poseen nota diferente de cero", 
                   "val_txt": "Promedio: ",
                   "descrip_adic":1,
                   },
        "mediaPondTotal": {"short_name": "Promedio ponderado", 
                   "descrip_calc": "Ponderación entre promedio, número de créditos y número de veces que vió la materia frente al total de créditos (se consideran para el cálculo todas las materias aprobadas con nota y créditos diferente de cero)", 
                   "val_txt": "Promedio: ",
                   "descrip_adic":0,},
    })


TXT_SEMESTRES_DICT = pd.DataFrame({
        "Sem1": {"txt": " primer "},
        "Sem2": {"txt": " dos "},
        "Sem3": {"txt": " tres "},
        "Sem4": {"txt": " cuatro "},
        "Sem5": {"txt": " cinco "}
    }) 
                    